/*
  Copyright (C) 2001 Kimmo Pekkola

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/*
  $Header: //rainbox/cvsroot/Rainmeter/Plugin/MeasureMemory.cpp,v 1.4 2001/09/01 13:00:10 rainy Exp $

  $Log: MeasureMemory.cpp,v $
  Revision 1.4  2001/09/01 13:00:10  rainy
  Slight changes in the interface. The value is now measured only once if possible.

  Revision 1.3  2001/08/19 09:15:21  rainy
  Added support for value invert.

  Revision 1.2  2001/08/12 15:45:45  Rainy
  Adjusted Update()'s interface.

  Revision 1.1.1.1  2001/08/11 10:58:19  Rainy
  Added to CVS.

*/

#include "MeasureMemory.h"

UINT CMeasureMemory::c_Value = 0;
int CMeasureMemory::c_Counter = -1;

CMeasureMemory::CMeasureMemory() : CMeasure()
{
	MEMORYSTATUS stat;
	GlobalMemoryStatus(&stat);
	m_MaxValue = stat.dwTotalPageFile + stat.dwTotalPhys;
}

CMeasureMemory::~CMeasureMemory()
{
}

bool CMeasureMemory::Update(CMeterWindow& meterWindow, int counter)
{
	MEMORYSTATUS stat;

	if(CMeasure::Update(meterWindow, counter)) return true;
	c_Counter = counter;

	GlobalMemoryStatus(&stat);
	c_Value = stat.dwTotalPageFile + stat.dwTotalPhys - stat.dwAvailPageFile - stat.dwAvailPhys;

	return false;
}

